Attribute VB_Name = "mdlMain"
Option Explicit
Public FSO As New Scripting.FileSystemObject



Public Function SplitFileByChunkSize(ByVal sFileName As String, ByVal lMaxChunkSize As Double) As Integer
  On Error GoTo err
  Dim iSplitNo As Integer 'Counts the # of Splited files
  Dim sFileFolder As String
  Dim sFileNameOnly As String
  Dim tsSource As TextStream
  Dim tsTemp As TextStream
  Dim sSplitFilesFolder As String
  Dim lFileSize As Double
  Dim lDueData As Double
  Dim vData As Variant
  Dim lToRead As Double
  Dim i As Integer
  Dim sTemp As String
  Dim sFormat As String

  Set tsSource = FSO.OpenTextFile(sFileName, ForReading)
  lFileSize = FileLen(sFileName)
  If lFileSize <= lMaxChunkSize Then
    MsgBox "This file cannot be split as filesize is less or equal to maximum chunksize"
    Exit Function
  End If
  sFileFolder = FSO.GetParentFolderName(sFileName)
  sFileNameOnly = FSO.GetFileName(sFileName)
  sSplitFilesFolder = sFileFolder & "\Splited Files of " & sFileNameOnly
  'Check if the folder already exist, if exists then delete it
  If FSO.FolderExists(sSplitFilesFolder) Then FSO.DeleteFolder sSplitFilesFolder
  FSO.CreateFolder (sSplitFilesFolder) 'create folder to store splited files
  'Start creating chunks of files
  iSplitNo = Int(lFileSize / lMaxChunkSize)
  lDueData = lFileSize Mod lMaxChunkSize
  If lDueData > 0 Then
    iSplitNo = iSplitNo + 1
  End If
  
  For i = 1 To Len(CStr(iSplitNo))
    sFormat = sFormat & "0"
  Next
  For i = 1 To iSplitNo
    sTemp = sSplitFilesFolder & "\" & sFileNameOnly & "." & Format(i, sFormat)
    lToRead = lMaxChunkSize
    If i = iSplitNo Then
      If lDueData > 0 Then
        lToRead = lDueData
      End If
    End If
    Set tsTemp = FSO.CreateTextFile(sTemp, True)
    tsTemp.Write (tsSource.Read(lToRead))
    tsTemp.Close
  Next
  tsSource.Close
  SplitFileByChunkSize = iSplitNo
  Exit Function
err:
  MsgBox err.Description
End Function

Public Function ClubFiles(sDestination As String, sFolder As String, bOverWrite As Boolean) As Integer
  On Error GoTo err
  Dim iClubedFilesCount As Integer
  Dim thisFolder As Folder
  Dim thisFile As File
  Dim tsTemp As TextStream
  Dim tsDestination As TextStream
  Set thisFolder = FSO.GetFolder(sFolder)
  If FSO.FileExists(sDestination) And bOverWrite = False Then
    MsgBox "'" & sDestination & "' already exists, action canceled"
    Exit Function
  End If
  Set tsDestination = FSO.CreateTextFile(sDestination, True)
  For Each thisFile In thisFolder.Files
    iClubedFilesCount = iClubedFilesCount + 1
    Set tsTemp = thisFile.OpenAsTextStream
    tsDestination.Write (tsTemp.Read(thisFile.Size))
    tsTemp.Close
  Next
  tsDestination.Close
  ClubFiles = iClubedFilesCount
  Exit Function
err:
  MsgBox err.Description
  ClubFiles = False
End Function
